/* Engine.cpp
   These functions handle all information pertaining to placing the sprites and
	 it's movement. 
*/

#include "Engine.h"
#include "SDL.h"

Engine::Engine()
{
	//velocity inits.
	vix = 1.5;
	viy = 0;

	//acceleration inits.
	ay = -9.8;
	ax = 0;

	//distance inits.
  dy = -5;
}

SDL_Surface* Engine::SetSurface(char *filename)
{
	SDL_Surface *temp1;
	SDL_Surface *temp2;
	temp1 = SDL_LoadBMP(filename);
	temp2 = SDL_DisplayFormat(temp1);
	SDL_FreeSurface(temp1);
	return temp2;
}

void Engine::DrawImage(SDL_Surface *surface, SDL_Surface *toSurface, int x, int y)
{
	SDL_Rect dest;
	dest.x = x;
	dest.y = y;
	SDL_BlitSurface(surface, NULL, toSurface, &dest);
}

void Engine::Init()
{
	SDL_Init(SDL_INIT_VIDEO); //initialize SDL
	SDL_WM_SetCaption("Free Fall Physics Demo", "Free Fall Physics Demo"); //title bar.

	screen = SDL_SetVideoMode(640, 480, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);

	SDL_ShowCursor(false);

	background = SetSurface("bg.bmp");
	DrawImage(background, screen, 0, 0);

	x = 580;
	y = 50;

	player = SetSurface("pleft.bmp");
	colorKey = SDL_MapRGB(player->format, 255, 0, 255);
	SDL_SetColorKey(player, SDL_SRCCOLORKEY | SDL_RLEACCEL, colorKey);
	DrawImage(player, screen, x, y);

}

void Engine::DrawScene()
{
	DrawImage(background, screen, 0,0);
	DrawImage(player, screen, x, y);
	SDL_Flip(screen);
}

void Engine::addX(int incriment)
{
	x -= incriment;
}

void Engine::addY(int incriment)
{
	y += incriment;
}

int Engine::getY()
{
	return y;
}

	